package game;

public class Direction implements Directions
{
    private int facing = getDefaultFacing();
    private int lastFacing = -1;

    public int getFacing(double speedX, double speedY)
    {
        setFromSpeed(speedX, speedY);
        return facing;
    }

    public void setFacing(int _facing)
    {
        changeFacing(_facing);
    }

    private void changeFacing(int _facing)
    {
        lastFacing = facing;
        facing = _facing;
    }

    public boolean didChange()
    {
        return lastFacing != facing;
    }

    private void setFromSpeed(double speedX, double speedY)
    {
        math.Measure measureX = new math.Measure(speedX);
        math.Measure measureY = new math.Measure(speedY);

        if ( speedX < 0
            && measureX.absolute() > measureY.absolute() )
            changeFacing(FACING_LEFT);
        else if ( speedX > 0
            && measureX.absolute() > measureY.absolute() )
            changeFacing(FACING_RIGHT);
        else if ( speedY < 0 )
            changeFacing(FACING_UP);
        else if ( speedY > 0 )
            changeFacing(FACING_DOWN);
        else
            facing = lastFacing;
    }

    protected int getDefaultFacing()
    {
        return FACING_UNDEFINED;
    }

}
