package game;
import java.awt.event.*;

public class Input
{
    public final static int NONE = 0;
    public final static int UP = 1;
    public final static int RIGHT = 2;
    public final static int DOWN = 3;
    public final static int LEFT = 4;
    public final static int EXIT = 5;
    public final static int ACTION = 6;
    public final static int OK = 7;
    public final static int HELP = 8;
    public final static int PAUSE = 9;

    private int keyInput = NONE;

    public void setInput(KeyEvent event)
    {
        switch ( event.getKeyCode() )
        {
            case KeyEvent.VK_UP:
            case KeyEvent.VK_NUMPAD8:
                keyInput = UP;
                break;
            case KeyEvent.VK_RIGHT:
            case KeyEvent.VK_NUMPAD6:
                keyInput = RIGHT;
                break;
            case KeyEvent.VK_DOWN:
            case KeyEvent.VK_NUMPAD2:
                keyInput = DOWN;
                break;
            case KeyEvent.VK_LEFT:
            case KeyEvent.VK_NUMPAD4:
                keyInput = LEFT;
                break;

            case KeyEvent.VK_SPACE:
                keyInput = ACTION;
                break;
            case KeyEvent.VK_ENTER:
                keyInput = OK;
                break;
            case KeyEvent.VK_ESCAPE:
                keyInput = EXIT;
                break;
            case KeyEvent.VK_F1:
                keyInput = HELP;
                break;
            case KeyEvent.VK_PAUSE:
            case KeyEvent.VK_P:
                keyInput = PAUSE;
                break;

            default:
                keyInput = NONE;
                break;
        }            

    }

    public void clear()
    {
        keyInput = NONE;
    }

    public int getInput()
    {
        return keyInput;
    }

}