package game;
import java.awt.*;

public class Rockets
{
    final int baseSpeed = 20;
    final int rocketMax = 40;
    protected Rocket rocket[] = new Rocket[rocketMax+1];

    public Rockets()
    {
        int i;
        for ( i=0; i<=rocketMax; i++ )
            rocket[i] = new Rocket();
    }

    public void appear(Graphics graph, Ground ground, Camera camera)
    {
        int i;
        for ( i=0; i<=rocketMax; i++ )
            if ( rocket[i].life.getIsAlive() )
                rocket[i].appear(graph, ground, camera);
    }

    public void act(Ground grnd)
    {
        int i;
        for ( i=0; i<=rocketMax; i++ )
            if ( rocket[i].life.getIsAlive() )
            {
                rocket[i].move(grnd);
                rocket[i].life.age();
            }
    }

    public void createOne(shape.Point newPosition, int facing)
    {
        int freeOne = -1;
        freeOne = findFreeOne();
        if ( freeOne >= 0 )
            createOneAt(newPosition, facing, freeOne);
    }

    private int findFreeOne()
    {
        int i, firstFree = -1;
        for ( i=0; i<=rocketMax; i++ )
        {
            if ( rocket[i].life.getIsDead() )
            {
                firstFree = i;
                break;
            }
        }
        return firstFree;
    }

    private void createOneAt(shape.Point newPosition, int facing, int freeOne)
    {
        rocket[freeOne] = new Rocket();
        rocket[freeOne].create();
        rocket[freeOne].position(newPosition);
        rocket[freeOne].push( getNewSpeedX(facing), getNewSpeedY(facing) );
    }

    private int getNewSpeedX(int facing)
    {
        int speedSignX = 0;
        switch ( facing )
        {
            case art.Directions.FACING_UP:
                speedSignX = 0;
                break;
            case art.Directions.FACING_RIGHT:
                speedSignX = 1;
                break;
            case art.Directions.FACING_DOWN:
                speedSignX = 0;
                break;
            case art.Directions.FACING_LEFT:
                speedSignX = -1;
                break;
        }
        return speedSignX * baseSpeed;
    }

    private int getNewSpeedY(int facing)
    {
        int speedSignY = 0;
        switch ( facing )
        {
            case art.Directions.FACING_UP:
                speedSignY = -1;
                break;
            case art.Directions.FACING_RIGHT:
                speedSignY = 0;
                break;
            case art.Directions.FACING_DOWN:
                speedSignY = 1;
                break;
            case art.Directions.FACING_LEFT:
                speedSignY = 0;
                break;
        }
        return speedSignY * baseSpeed;
    }

}